    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------
    028     * KeyedValues.java
    029     * ----------------
    030     * (C) Copyright 2002-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: KeyedValues.java,v 1.3.2.1 2005/10/25 21:29:13 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 23-Oct-2002 : Version 1 (DG);
    040     * 12-Jan-2005 : Updated Javadocs to specify new behaviour when key
    041     *               is not recognised (DG);
    042     *
    043     */
    044
    045    package org.jfree.data;
    046
    047    import java.util.List;
    048
    049    /**
    050     * An ordered list of (key, value) items.
    051     *
    052     * @see Values
    053     * @see DefaultKeyedValues
    054     */
    055    public interface KeyedValues extends Values {
    056
    057        /**
    058         * Returns the key associated with an item (value).
    059         *
    060         * @param index  the item index (zero-based).
    061         *
    062         * @return The key.
    063         *
    064         * @throws IndexOutOfBoundsException if <code>index</code> is out of bounds.
    065         */
    066        public Comparable getKey(int index);
    067
    068        /**
    069         * Returns the index for a given key.
    070         *
    071         * @param key  the key.
    072         *
    073         * @return The index, or <code>-1</code> if the key is unrecognised.
    074         */
    075        public int getIndex(Comparable key);
    076
    077        /**
    078         * Returns the keys for the values in the collection.  Note that you can
    079         * access the values in this collection by key or by index.  For this
    080         * reason, the key order is important - this method should return the keys
    081         * in order.  The returned list may be unmodifiable.
    082         *
    083         * @return The keys (never <code>null</code>).
    084         */
    085        public List getKeys();
    086
    087        /**
    088         * Returns the value for a given key.
    089         *
    090         * @param key  the key.
    091         *
    092         * @return The value (possibly <code>null</code>).
    093         *
    094         * @throws UnknownKeyException if the key is not recognised.
    095         */
    096        public Number getValue(Comparable key);
    097
    098    }